use std::io::Write;
use super::{Error, SectorWriter};

pub struct BinCueWriter {
    _bin_out:      std::boxed::Box<dyn Write>,
    sector_count: usize
}

impl BinCueWriter {
    pub fn new<T: Write + 'static>(writer: T) -> BinCueWriter {
        BinCueWriter{_bin_out: std::boxed::Box::new(writer), sector_count: 0}
    }
}

impl SectorWriter for BinCueWriter {
    fn write(&mut self) -> Result<(), Error> {
        self.sector_count += 1;

        Err(Error::not_implemented("write for BinCueWriter"))
    }

    fn sector_written_count(&self) -> usize {
        self.sector_count
    }
}